
package de.ivu.elect.presentation.ergebnis;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.ergebnis.boundary.ErgebnisSessionSelect;
import de.ivu.elect.business.ergebnis.entity.ErgebnisLogEintrag;
import de.ivu.elect.jee.faces.PreConditionCheck;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.hilfe.OnlineHilfeId;
import de.ivu.elect.presentation.security.AbstractGebietSecurityFilter;

@OnlineHilfeId("202")
@Named(AbstractErgebnisLogEintragSearchView.COMPONENT_NAME)
public class ErgebnisLogEintragSearchView extends AbstractErgebnisLogEintragSearchView {

  private static final long serialVersionUID = 1L;

  @Inject
  private transient ErgebnisSessionSelect ergebnisSessionSelect;

  public ErgebnisLogEintragSearchView() {
    super();
  }

  @PreConditionCheck
  public String checkPreCondition() {
    if (!ergebnisSessionSelect.isSelected()) {
      return getStartViewId();
    }

    return null;
  }

  @Override
  protected AbstractGebietSecurityFilter<ErgebnisLogEintrag> getGebietSecurityFilter() {
    return KEIN_GEBIET_SECURITY_FILTER;
  }

  /**
   * @deprecated To be removed...
   * @see ErgebnisLogEintragSearchView#initSearchParametersByContext
   */
  @Deprecated
  @Override
  public void presetSearchParameters() {
    // To be removed...
  }

  @Override
  protected void initSearchParametersByContext() {
    super.initSearchParametersByContext();

    searchParameters.setErgebnis(ergebnisSessionSelect.getEntity());
    searchParameters.setErgebnisLogEintragArt(null);
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    // nichts zu tun
  }

  @Override
  public int getDefaultPageSize() {
    return Math.max(super.getDefaultPageSize(), getPageSizeMax());
  }
}
